#ifndef _initglext_h
#define _initglext_h

#include <windows.h>		//      WinAPI
#include <GL/gl.h> 		//      OpenGL
#include "glext.h"


// This is a define that we use for our function pointers
#define APIENTRYP APIENTRY *

// Here we include the vertex and fragment shader defines
#define GL_VERTEX_SHADER_ARB              0x8B31
#define GL_FRAGMENT_SHADER_ARB            0x8B30

// This is what GL uses for handles when using extensions
typedef unsigned int GLhandleARB;
typedef char GLcharARB;


// Here we extern our functions to be used elsewhere
extern PFNGLCREATESHADEROBJECTARBPROC glCreateShaderObjectARB;
extern PFNGLSHADERSOURCEARBPROC glShaderSourceARB;
extern PFNGLCOMPILESHADERARBPROC glCompileShaderARB;
extern PFNGLCREATEPROGRAMOBJECTARBPROC glCreateProgramObjectARB;
extern PFNGLATTACHOBJECTARBPROC glAttachObjectARB;
extern PFNGLLINKPROGRAMARBPROC glLinkProgramARB;
extern PFNGLUSEPROGRAMOBJECTARBPROC glUseProgramObjectARB;
extern PFNGLUNIFORM1IARBPROC glUniform1iARB;
extern PFNGLUNIFORM1FARBPROC glUniform1fARB;
extern PFNGLUNIFORM2FARBPROC glUniform2fARB;
extern PFNGLUNIFORM3FARBPROC glUniform3fARB;
extern PFNGLUNIFORM4FARBPROC glUniform4fARB;
extern PFNGLGETUNIFORMLOCATIONARBPROC glGetUniformLocationARB;
extern PFNGLDETACHOBJECTARBPROC glDetachObjectARB;
extern PFNGLDELETEOBJECTARBPROC glDeleteObjectARB;
extern PFNGLGETOBJECTPARAMETERIVARBPROC glGetObjectParameterivARB;


// ARB_vertex_program extension
extern PFNGLGENPROGRAMSARBPROC					glGenProgramsARB;
extern PFNGLDELETEPROGRAMSARBPROC				glDeleteProgramsARB;
extern PFNGLBINDPROGRAMARBPROC					glBindProgramARB;
extern PFNGLISPROGRAMARBPROC					glIsProgramARB;

extern PFNGLPROGRAMSTRINGARBPROC				glProgramStringARB;
extern PFNGLGETPROGRAMIVARBPROC					glGetProgramivARB;

extern PFNGLVERTEXATTRIB4FARBPROC				glVertexAttrib4fARB;
extern PFNGLVERTEXATTRIB4FVARBPROC				glVertexAttrib4fvARB;

extern PFNGLVERTEXATTRIB3FARBPROC				glVertexAttrib3fARB;
extern PFNGLVERTEXATTRIB3FVARBPROC				glVertexAttrib3fvARB;

extern PFNGLVERTEXATTRIBPOINTERARBPROC			glVertexAttribPointerARB;
extern PFNGLENABLEVERTEXATTRIBARRAYARBPROC		glEnableVertexAttribArrayARB;
extern PFNGLDISABLEVERTEXATTRIBARRAYARBPROC		glDisableVertexAttribArrayARB;


extern PFNGLPROGRAMLOCALPARAMETER4FARBPROC		glProgramLocalParameter4fARB;
extern PFNGLPROGRAMLOCALPARAMETER4FVARBPROC		glProgramLocalParameter4fvARB;

extern PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC	glGetProgramLocalParameterfvARB;

extern PFNGLPROGRAMENVPARAMETER4FARBPROC		glProgramEnvParameter4fARB;
extern PFNGLPROGRAMENVPARAMETER4FVARBPROC		glProgramEnvParameter4fvARB;

extern PFNGLGETPROGRAMENVPARAMETERFVARBPROC		glGetProgramEnvParameterfvARB;



// multitexture functions
typedef void (APIENTRYP PFNGLACTIVETEXTUREARBPROC) (GLenum texture);
extern PFNGLACTIVETEXTUREARBPROC				glActiveTextureARB;

typedef void (APIENTRYP PFNGLMULTITEXCOORD2FARBPROC) (GLenum target, GLfloat s, GLfloat t);  
extern PFNGLMULTITEXCOORD2FARBPROC				glMultiTexCoord2fARB;

typedef void (APIENTRYP PFNGLGENBUFFERSARBPROC) (GLsizei n, GLuint *buffers); 
extern PFNGLGENBUFFERSARBPROC glGenBuffersARB;

typedef void (APIENTRYP PFNGLBINDBUFFERARBPROC) (GLenum target, GLuint buffer); 
extern PFNGLBINDBUFFERARBPROC glBindBufferARB;

typedef void (APIENTRYP PFNGLBUFFERDATAARBPROC) (GLenum target, GLsizeiptrARB size, const GLvoid *data, GLenum usage); 
extern PFNGLBUFFERDATAARBPROC glBufferDataARB;

typedef void (APIENTRY * PFNGLDELETEBUFFERSARBPROC) (GLsizei n, const GLuint *buffers);
extern PFNGLDELETEBUFFERSARBPROC glDeleteBuffersARB;



typedef BOOL (WINAPI * PFNWGLSWAPINTERVALEXTPROC) (int interval);
typedef int (WINAPI * PFNWGLGETSWAPINTERVALEXTPROC) (void); 
/* WGL_EXT_swap_control */
extern PFNWGLSWAPINTERVALEXTPROC wglSwapIntervalEXT;
extern PFNWGLGETSWAPINTERVALEXTPROC wglGetSwapIntervalEXT;


 

void InitExt(void);

#endif _initglext_h
