#include <windows.h>
#include <GL\gl.h>
#include <GL\glu.h>
#include "camera2.h"
#include <stdlib.h>
#include <stdio.h>

#pragma comment(lib, "winmm.lib")

#define kSpeed	40.0f									

float g_FrameInterval2 = 0.0f;

float g_fPS    = 0.0f;


extern HWND hwnd;

enum AXIS
{
	x	= 0,
	y	= 1,
	z	= 2
};



void CalculateFrameRate2()
{
	static float framesPerSecond = 0.0f;
    static float lastTime			= 0.0f;
	static char strFrameRate[50] = {0};			
	static float frameTime = 0.0f;
    float currentTime = timeGetTime() * 0.001f;				

 	g_FrameInterval2 = currentTime - frameTime;
	frameTime = currentTime;


    ++framesPerSecond;


    if( currentTime - lastTime > 1.0f )
    {

	    lastTime = currentTime;

		g_fPS = framesPerSecond;
        framesPerSecond = 0;
    }
}

C_Camera2::C_Camera2()
{
	SetCameraPos(-60,-10,50);
	SetCameraAngle (0, 220, 0);
	LinearMoveFlag=false;
	radius=7;

}


C_Camera2::~C_Camera2()
{

}

void C_Camera2::SetCameraPos(float X, float Y, float Z)
{
	position[x]=X;
	position[y]	=Y;
	position[z]=Z;
}


void C_Camera2::SetCameraAngle(float AngleX, float AngleY, float AngleZ)
{
	angle[x]=AngleX;
	angle[y]=AngleY;
	angle[z]=AngleZ;
}

void C_Camera2::SetCameraSpeed()
{
	CalculateFrameRate2();
	speed = kSpeed * g_FrameInterval2;
}

void C_Camera2::SetCameraFps(HWND hwnd, int count)
{
//	char FR[50];
//	int FPS=_time.GetFPS();
//	sprintf(FR,  "FPS=%i", FPS);	
//	SetWindowText(hwnd, FR);
}



void C_Camera2::RotateCamera(float angleX, float angleY, float angleZ)
{
	angle[x]+=angleX;
	angle[y]+=angleY;
	angle[z]+=angleZ;
	CheckCameraAngle();
} 


void C_Camera2::CheckCameraAngle(void)
{
if (angle[x]>=90)  angle[x]=90;
if (angle[x]<-90)   angle[x]=-90;
if (angle[y]>=360) angle[y]-=360;
if (angle[y]<0)  angle[y]+=360;
if (angle[z]>=90)  angle[z]=90;
if (angle[z]<-90)   angle[z]=-90;
}

void C_Camera2::MoveCamera (float speed)
{
	if (LinearMoveFlag)
	{
		position[z] +=speed;
	}
	else
	{
		position[x] -= float(sin(6.28/360*angle[y]) * speed);
		position[y] += float(sin(6.28/360*angle[x]) * speed);
		position[z] += float(cos(6.28/360*angle[y]) * speed);
	}
}

void C_Camera2::StrafeCamera (float speed)
{
	if (LinearMoveFlag)
	{
		position[x] +=speed;
	}
	else
	{
		position[x] -= float(sin(6.28/360*(angle[y]+90)) * speed);
		position[y] -= float(sin(6.28/360*angle[z]) * speed);
		position[z] += float(cos(6.28/360*(angle[y]+90)) * speed);
	}
}

void C_Camera2::CheckMouse()
{
	float angleY = 0.0f;
	float angleZ = 0.0f;
	POINT mousePos;
	int middleX = GetSystemMetrics(SM_CXSCREEN) >> 1;
	int middleY = GetSystemMetrics(SM_CYSCREEN) >> 1;

	if (L_But_Pressed == true) MoveCamera (speed);	
	if (R_But_Pressed == true) MoveCamera (-speed);

	GetCursorPos(&mousePos);							
	

	if( (mousePos.x == middleX) && (mousePos.y == middleY) ) return;


	SetCursorPos(middleX, middleY);							

	angleY = (float)( (mousePos.x - middleX) ) / 5.0f;		
	angleZ = (float)( (mousePos.y - middleY) ) / 5.0f;

	RotateCamera(float(angleZ), 0, 0);			
	RotateCamera(0, float(angleY), 0);
}


void C_Camera2::CheckKeyboard(void)
{
	if ((keys[VK_UP]==true)||(keys['W']==true)) MoveCamera(speed);	
	if ((keys[VK_DOWN]==true)||(keys['X']==true)) MoveCamera(-speed);
	if ((keys[VK_LEFT]==true)||(keys['A']==true)) StrafeCamera(-speed);
	if ((keys[VK_RIGHT]==true)||(keys['D']==true)) StrafeCamera(speed);
	if (keys['Q']==true) RotateCamera(0, 0, speed*3);
	if (keys['E']==true) RotateCamera(0 ,0, speed*3);
}


void C_Camera2::UpdateCamera	(void)
{
	SetCameraSpeed();
	CheckMouse();
	CheckKeyboard();
	glLoadIdentity();
	glRotatef(angle[x],1,0,0);
	glRotatef(angle[y],0,1,0);
	glRotatef(angle[z],0,0,1);
	glTranslatef(position[x], position[y], position[z]);
}

void C_Camera2::ResetCamera()
{
	for (int i=0; i<3; i++)
	{
		position[i]=0;
		angle[i]=0;
	}
}
