#include "frustum.h"					//    clip.h,    C_Clip

#define LEFT		0			//    
#define RIGHT		1
#define TOP		2
#define BOTTOM	3
#define FRONT		4
#define BACK		5

#define A			0
#define B			1
#define C			2
#define D			3



C_Clip::C_Clip()
{

}


C_Clip::~C_Clip()
{

}


void C_Clip::GetModelViewMatrix()
{
	glGetFloatv(GL_MODELVIEW_MATRIX, *m_model);
}


void C_Clip::GetProjectionMatrix()
{
	glGetFloatv(GL_PROJECTION_MATRIX, *m_proj);
}


void C_Clip::GetClippingMatrix()
{
	float *m,*p,t;
	memset(m_clip,0, 16*sizeof(GLfloat));
	for (int i=0;i<=3;i++)
		for (int j=0; j<=3; j++)
			for (int k=0; k<=3; k++)
			{
//				m_clip[j][i]+=m_model[j][k]*m_proj[k][i];
				m = &m_model[j][k];
				p = &m_proj[k][i];

				_asm mov	eax, m
				_asm mov	ebx, p
				_asm fld	DWORD PTR[eax]
				_asm fmul	DWORD PTR[ebx]
				_asm fstp	dword ptr  [t]

				m_clip[j][i]+=t;
			}


		_asm {
//				mov	eax,
//				mov ebx, V
//				fld	DWORD PTR[eax]
//				fmul DWORD PTR[ebx]
//
//				fld	DWORD PTR[eax+4]
//				fmul DWORD PTR[ebx+4]
//
//				fld	DWORD PTR[eax+8]
//				fmul DWORD PTR[ebx+8]

//				faddp           st(2),st(0)
//				faddp           st(1),st(0)
//				fstp dword ptr  [dot]
			}

}


void C_Clip::GetSideInVolume()
{
	frustum[LEFT][A]=m_clip[0][3]+m_clip[0][0];		//   X     
	frustum[LEFT][B]=m_clip[1][3]+m_clip[1][0];		//   Y     
	frustum[LEFT][C]=m_clip[2][3]+m_clip[2][0];		//   Z     
	frustum[LEFT][D]=m_clip[3][3]+m_clip[3][0];		//   D       

	frustum[RIGHT][A]=m_clip[0][3]-m_clip[0][0];		//   X     
	frustum[RIGHT][B]=m_clip[1][3]-m_clip[1][0];		//   Y     
	frustum[RIGHT][C]=m_clip[2][3]-m_clip[2][0];		//   Z     
	frustum[RIGHT][D]=m_clip[3][3]-m_clip[3][0];		//   D       

	frustum[BOTTOM][A]=m_clip[0][3]+m_clip[0][1];	//   X     
	frustum[BOTTOM][B]=m_clip[1][3]+m_clip[1][1];	//   Y     
	frustum[BOTTOM][C]=m_clip[2][3]+m_clip[2][1];	//   Z     
	frustum[BOTTOM][D]=m_clip[3][3]+m_clip[3][1];	//   D       

	frustum[TOP][A]=m_clip[0][3]-m_clip[0][1];		//   X     
	frustum[TOP][B]=m_clip[1][3]-m_clip[1][1];		//   Y     
	frustum[TOP][C]=m_clip[2][3]-m_clip[2][1];		//   Z     
	frustum[TOP][D]=m_clip[3][3]-m_clip[3][1];		//   D       

	frustum[FRONT][A]=m_clip[0][3]+m_clip[0][2];	//   X     
	frustum[FRONT][B]=m_clip[1][3]+m_clip[1][2];	//   Y     
	frustum[FRONT][C]=m_clip[2][3]+m_clip[2][2];	//   Z     
	frustum[FRONT][D]=m_clip[3][3]+m_clip[3][2];	//   D       

	frustum[BACK][A]=m_clip[0][3]-m_clip[0][2];		//   X     
	frustum[BACK][B]=m_clip[1][3]-m_clip[1][2];		//   Y     
	frustum[BACK][C]=m_clip[2][3]-m_clip[2][2];		//   Z     
	frustum[BACK][D]=m_clip[3][3]-m_clip[3][2];		//   D       
}


void C_Clip::NormilizeSideInVolume()
{
	float *f1,*f2, *m, f;
	for (int i=0;i<6;i++)		//     
	{
		float magnitude=0;

		for (int k=0;k<3;k++)	//       X,Y,Z   
		{
//			magnitude+=frustum[i][k]*frustum[i][k];
			f1 = &frustum[i][k];
			f2 = &frustum[i][k];

				_asm mov	eax, f1
				_asm mov	ebx, f2
				_asm fld	DWORD PTR[eax]
				_asm fmul	DWORD PTR[ebx]
				_asm fstp	dword ptr  [f]
			magnitude+=f;

		}
		m = &magnitude;
		_asm mov	eax, m
		_asm fld	DWORD PTR[eax]
		_asm fsqrt
		_asm fstp	dword ptr  [magnitude]

//		magnitude=(float)sqrt(magnitude);			//       X,Y,Z 		

		for (int j=0;j<4;j++)
		{
			f1 = &frustum[i][j];
//			frustum[i][j]/=magnitude;
			//        D
				_asm mov	eax, f1
				_asm mov	ebx, m
				_asm fdivr	DWORD PTR[ebx]
				_asm fstp	dword ptr  [f1]
		}
	}
}

bool C_Clip::BBOXinVolume(float min_X, float min_Y, float min_Z, float max_X, float max_Y, float max_Z)
{
	float d1,d2,d3,d4,d5,d6,d7,d8;
	GetModelViewMatrix();
	GetProjectionMatrix();
	GetClippingMatrix();
	GetSideInVolume();
	NormilizeSideInVolume();
	for (int i=0;i<6;i++)
	{
		d1 = frustum[i][A]*min_X+frustum[i][B]*min_Y+frustum[i][C]*min_Z+frustum[i][D];
		d2 = frustum[i][A]*max_X+frustum[i][B]*min_Y+frustum[i][C]*min_Z+frustum[i][D];
		d3 = frustum[i][A]*max_X+frustum[i][B]*min_Y+frustum[i][C]*max_Z+frustum[i][D];
		d4 = frustum[i][A]*min_X+frustum[i][B]*min_Y+frustum[i][C]*max_Z+frustum[i][D];

		d5 = frustum[i][A]*min_X+frustum[i][B]*max_Y+frustum[i][C]*min_Z+frustum[i][D];
		d6 = frustum[i][A]*max_X+frustum[i][B]*max_Y+frustum[i][C]*min_Z+frustum[i][D];
		d7 = frustum[i][A]*max_X+frustum[i][B]*max_Y+frustum[i][C]*max_Z+frustum[i][D];
		d8 = frustum[i][A]*min_X+frustum[i][B]*max_Y+frustum[i][C]*max_Z+frustum[i][D];
		if ((d1<=0)&&(d2<=0)&&(d3<=0)&&(d3<=0)&&(d4<=0)&&(d5<=0)&&(d6<=0)&&(d7<=0)&&(d8<=0)) return false;;	
	}
	return true;
}


bool C_Clip::PolygonInVolume(float v1[3], float v2[3], float v3[3])
{
	float d1,d2,d3;
	for (int i=0;i<6;i++)	//      6-  
	{
//        i-  
		d1=frustum[i][A]*v1[0]+frustum[i][B]*v1[1]+frustum[i][C]*v1[2]+frustum[i][D];
//        i-  
		d2=frustum[i][A]*v2[0]+frustum[i][B]*v2[1]+frustum[i][C]*v2[2]+frustum[i][D];
//        i-  
		d3=frustum[i][A]*v3[0]+frustum[i][B]*v3[1]+frustum[i][C]*v3[2]+frustum[i][D];
//           ,         
	if ((d1<=0)&&(d2<=0)&&(d3<=0)) return false;	
	}
	return true;		//       
}

