#include "window.h"
#include "opengl.h"
#include "render.h"
#include "camera2.h"
#include "texture.h"
#include "InitGlExt.h"


bool bFullScr = false;
bool bFrustum = true;
bool bshader_enable = false;
bool bbox_visible = false;
bool b_vbo=false;
bool v_sync=false;



unsigned int HORZ_RES=800;
unsigned int VERT_RES=600;
unsigned int bpp=32;
DWORD DwStyle;
HWND hwnd;

bool		L_But_Pressed = false;		
bool		R_But_Pressed = false;	
bool		keys[256]={false};

COpenGL  * opengl;
CRender  * render;
C_Camera2 * camera;
CTexture * tex;



LONG WINAPI WndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch (iMsg)
		{
			case WM_CREATE:
			break;

			case WM_SIZE:
			break;

			case WM_PAINT: 	  		
			break;

			case WM_KEYDOWN:
			camera->keys[wParam]=true;
			switch(wParam)
				{						
					case VK_ESCAPE:		
					PostQuitMessage(0);
					break;


					case 'M':
						tex->SaveTGA("file.tga", HORZ_RES, VERT_RES);
					break;

					case VK_F5:
					v_sync=!v_sync;
					break;

					case VK_F4:
					b_vbo=!b_vbo;
					break;

					case VK_F3:
						bbox_visible=!bbox_visible;
					break;

					case VK_F2:
						bshader_enable=!bshader_enable;
					break;

					case VK_F1:
						bFrustum=!bFrustum;
					break;

					case 'R':
						render->draw_array=!render->draw_array;
					break;



				}
			break;
			
			case WM_KEYUP:
			camera->keys[wParam]=false;
			break;

		case WM_RBUTTONDOWN:
		camera->R_But_Pressed = true;
		break;

		case WM_LBUTTONDOWN:
		camera->L_But_Pressed = true;	
		break;

		case WM_RBUTTONUP:
		camera->R_But_Pressed = false;
		break;

		case WM_LBUTTONUP:
		camera->L_But_Pressed = false;
		break;


			case WM_DESTROY:
			PostQuitMessage(0);
			break;

			default:
			break;
		}

	return DefWindowProc (hwnd, iMsg, wParam, lParam);  
}


void CreateMyWindow(HINSTANCE hInstance, int nCmdShow)
{
	WNDCLASSEX  wndclass;
	wndclass.cbSize        = sizeof (wndclass);
	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon (NULL, IDI_WINLOGO);
	wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH) GetStockObject (BLACK_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "GL Window";					
	wndclass.hIconSm       = LoadIcon (NULL, IDI_WINLOGO);
	RegisterClassEx (&wndclass);

 	if(MessageBox(NULL, "Do you want switch to fullscreen mode (Recommended)", "Options", MB_YESNO | MB_ICONQUESTION) == IDYES)
		bFullScr = true;
	if (bFullScr)
	{
		DwStyle = WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
		HORZ_RES = 800;
		VERT_RES = 600;
	}
	else DwStyle = WS_OVERLAPPEDWINDOW | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
	hwnd = CreateWindow("GL Window","GL Window", DwStyle, 0, 0, HORZ_RES, VERT_RES, NULL, NULL,	hInstance, NULL);
	if(bFullScr)
	{
		opengl->SetVideomodeWnd(HORZ_RES, VERT_RES, bpp);
	}
	ShowWindow (hwnd, nCmdShow);
	UpdateWindow (hwnd);	
}

void InitEngine()
{
	render = new CRender;
	opengl = new COpenGL;
	camera = new C_Camera2;
	opengl->InitGL(hwnd);
	opengl->InitViewPort(HORZ_RES, VERT_RES);
	opengl->InitLight();

	InitExt();
	render->Init();
//	InitFMOD("sounds\\1.mp3");
}

void DestroyEngine()
{
		opengl->DeInitGL(hwnd);
		render->Free();
		if (bFullScr == true) opengl->ResetVideoMode();
		delete render;
		delete opengl;
		delete camera;
}

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR CmdLine, int nCmdShow)
{
	CreateMyWindow(hInstance, nCmdShow);
	InitEngine();
	MSG	msg;
	while(1)
		{													
			if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
				{ 
					if(msg.message == WM_QUIT) break;
           			TranslateMessage(&msg);
					DispatchMessage(&msg);
       			}
			else 
				{
					camera->UpdateCamera();
					render->MainDraw();
					opengl->UpDateScene();	
				} 
		}
	DestroyEngine();
	return(msg.wParam);
}