#include "mesh3ds.h"


mesh3ds::mesh3ds()
{
	num_obj =	0;
	num_mtr =	0;
	ObjID	=	0;
	MatID	=	0;
}


mesh3ds::~mesh3ds()
{
	for (int i=0; i<pScene->num_objects; i++)
	{
		delete []pScene->pObject[i].pIndFaceArray;
		delete []pScene->pObject[i].pSmoothFaceArray;
		delete []pScene->pObject[i].pVertex;
		delete []pScene->pObject[i].pVertexST;
		delete []pScene->pObject[i].pVertexArray;
		delete []pScene->pObject[i].pVertexSTArray;
		delete []pScene->pObject[i].pNormalArray;
		delete []pScene->pObject[i].pTangentArray;
		delete []pScene->pObject[i].pBinormalArray;
		delete []pScene->pObject[i].pFace;
		delete []pScene->pObject[i].strTextureName;
		delete []pScene->pObject[i].strObjectName;
  }
}


char mesh3ds::ReadChar(void)
{
		char symbol;
		fread(&symbol, 1, sizeof(symbol), P_File);
		return symbol;	
};

unsigned int mesh3ds::ReadChunk(chunk *p_chunk)
{
		p_chunk->bytes = fread(&p_chunk->label, 1, sizeof(p_chunk->label), P_File);
		p_chunk->bytes +=fread(&p_chunk->length, 1, sizeof(p_chunk->length), P_File);
		return p_chunk->bytes;
};

void mesh3ds::SetChunkPointer(unsigned int ptr)
{
		fseek(P_File, ptr, SEEK_CUR);
};

unsigned long mesh3ds::GetChunkPosition()
{
		return ftell(P_File);
}

void mesh3ds::SetChunkPosition(unsigned int ptr)
{
		fseek(P_File, ptr, SEEK_SET);
}


unsigned int mesh3ds::ReadMaterialName (void)
{
		char tmp_name[256];
		unsigned int index=0;
		unsigned char letter;
		strcpy (tmp_name,"Default name");
		letter=ReadChar();
		if (letter==0) return index;
		tmp_name [index]=letter;
		index++;
		do
		{
			letter = ReadChar ();
			tmp_name [index]=letter;
			index++;
		 }
		while (letter!=0); 
		tmp_name [index-1]=0;
		printf ("Found material name     : %s\n",tmp_name);
	
		pScene->pMaterial[MatID].strMaterialName = new char[index];
		strcpy(pScene->pMaterial[MatID].strMaterialName, tmp_name);
		return index;
}



unsigned int mesh3ds::ReadObjectName (void)
{
		char tmp_name[256];
		unsigned int index=0;
		unsigned char letter;
		strcpy (tmp_name,"Default name");
		letter=ReadChar();
		if (letter==0) return index; // dummy object
		tmp_name [index]=letter;
		index++;
		do
		{
				letter = ReadChar ();
				tmp_name [index]=letter;
				index++;
		}
		while (letter!=0);
		tmp_name [index-1]=0;
		printf ("Found object name:  %s\n",tmp_name);
		pScene->pObject[ObjID].strObjectName = new char[index];
		strcpy(pScene->pObject[ObjID].strObjectName, tmp_name);
		return index;
}


unsigned int mesh3ds::ReadTextureName (void)
{
		char tmp_name[256];
		unsigned int index=0;
		unsigned char letter;
		strcpy (tmp_name,"Default name");
		letter=ReadChar();
		if (letter==0) return index; // dummy object
		tmp_name [index]=letter;
		index++;
		do
		{
				letter = ReadChar ();
				tmp_name [index]=letter;
				index++;
		}
		while (letter!=0);
		tmp_name [index-1]=0;
		printf ("Found texture name : %s\n",tmp_name);
		pScene->pObject[ObjID].strTextureName = new char[index];
		strcpy(pScene->pObject[ObjID].strTextureName, tmp_name);
		return index;
}

unsigned int mesh3ds::ReadFileName (void)
{
		char tmp_name[256];
		unsigned int index=0;
		unsigned char letter;
		strcpy (tmp_name,"Default name");
		letter=ReadChar();
		if (letter==0) return index;
		tmp_name [index]=letter;
		index++;
		do
		{
				letter = ReadChar ();
				tmp_name [index]=letter;
				index++;
		 }
		while (letter!=0);
		tmp_name [index-1]=0;
		printf ("Found mapping file name : %s\n",tmp_name);
		pScene->pMaterial[MatID].strFileName = new char[index];
		strcpy(pScene->pMaterial[MatID].strFileName, tmp_name);
		return index;
}


void mesh3ds::ReadMapSpecular(chunk *p_chunk)
{
		chunk *tmp_chunk;
		tmp_chunk = new chunk;
		while(p_chunk->bytes<p_chunk->length)
		{
				ReadChunk(tmp_chunk);
				p_chunk->bytes+=tmp_chunk->length;
				switch(tmp_chunk->label)
				{
						case MAPPING_NAME:
						{
//								printf("MAPPING_NAME       %0x          %i\n", tmp_chunk->label, tmp_chunk->length); 
								ReadFileName();
						}
						break;

						default:
						{
								SetChunkPointer(tmp_chunk->length-6);	
						}
						break;
				}
		}
		delete tmp_chunk;
//		printf("Bytes read in MapChunk          %i\n", p_chunk->bytes); 
}


void mesh3ds::ReadMapChunk(chunk *p_chunk)
{
		chunk *tmp_chunk;
		tmp_chunk = new chunk;
		while(p_chunk->bytes<p_chunk->length)
		{
				ReadChunk(tmp_chunk);
				p_chunk->bytes+=tmp_chunk->length;
				switch(tmp_chunk->label)
				{
						case MAPPING_NAME:
						{
//								printf("MAPPING_NAME       %0x          %i\n", tmp_chunk->label, tmp_chunk->length); 
								ReadFileName();
						}
						break;

						default:
						{
								SetChunkPointer(tmp_chunk->length-6);	
						}
						break;
				}
		}
		delete tmp_chunk;
//		printf("Bytes read in MapChunk          %i\n", p_chunk->bytes); 
}


void mesh3ds::ReadEditMaterialChunk(chunk *p_chunk)
{
		chunk *tmp_chunk;
		tmp_chunk = new chunk;
		while(p_chunk->bytes<p_chunk->length)
		{
				ReadChunk(tmp_chunk);
				p_chunk->bytes+=tmp_chunk->length;
				switch(tmp_chunk->label)
				{
						case MATNAME:
						{	
//								printf("MATNAME            %0x          %i\n", tmp_chunk->label, tmp_chunk->length); 
								ReadMaterialName();
//								SetChunkPointer(tmp_chunk->length-6);
						}
						break;

						case MATERIAL_AMBIENT:
						{
//								printf("MATERIAL_AMBIENT   %0x          %i\n", tmp_chunk->label, tmp_chunk->length); 
								SetChunkPointer(tmp_chunk->length-6);
						}
						break;

						case TEXTURE_MAP:
						{
//								printf("TEXTURE_MAP        %0x          %i\n", tmp_chunk->label, tmp_chunk->length); 
								ReadMapChunk(tmp_chunk);
//								SetChunkPointer(tmp_chunk->length-6);
						}
						break;

						case MAP_SPECULAR:
						{
//								printf("MAP_SPECULAR        %0x          %i\n", tmp_chunk->label, tmp_chunk->length); 
								ReadMapSpecular(tmp_chunk);
//								SetChunkPointer(tmp_chunk->length-6);
						}
						break;

						default:
						{
								SetChunkPointer(tmp_chunk->length-6);
//								printf("UNK MATRL            %0x          %i\n", tmp_chunk->label, tmp_chunk->length); 
						}
						break;
				}
		}
		delete tmp_chunk;
//		printf("Bytes read in EditMaterialChunk  %i\n", p_chunk->bytes); 
}



void mesh3ds::ReadVertexData(void)
{
		unsigned short numb_v, i;
		fread(&numb_v, 1, sizeof(numb_v), P_File);
		printf ("Found (%d) number of vertices\n",numb_v); 
		pScene->pObject[ObjID].num_vertex = numb_v;
		pScene->pObject[ObjID].pVertex = new Vector3D[numb_v];
		for(i=0;i<numb_v; i++)
				{
					fread(&pScene->pObject[ObjID].pVertex[i].x, 1, sizeof(float), P_File);
					fread(&pScene->pObject[ObjID].pVertex[i].z, 1, sizeof(float), P_File);
					fread(&pScene->pObject[ObjID].pVertex[i].y, 1, sizeof(float), P_File);
					pScene->pObject[ObjID].pVertex[i].z = -pScene->pObject[ObjID].pVertex[i].z;
//					printf ("vertices %i   x=%f, y=%f, z=%f\n", i,pScene->pObject[ObjID].pVertex[i].x,pScene->pObject[ObjID].pVertex[i].y,pScene->pObject[ObjID].pVertex[i].z);
				}
}

void mesh3ds::ReadMappingData(void)
{
		unsigned short numb_m, i;
		fread(&numb_m, 1, sizeof(numb_m), P_File);
		printf ("Found (%d) number of mapping vertex\n",numb_m);
		pScene->pObject[ObjID].num_vertex_st = numb_m;
		pScene->pObject[ObjID].pVertexST = new Vector2D[numb_m];
		for(i=0;i<numb_m; i++)
		{
				fread(&pScene->pObject[ObjID].pVertexST[i].x, 1, sizeof(float), P_File);
				fread(&pScene->pObject[ObjID].pVertexST[i].y, 1, sizeof(float), P_File);
				pScene->pObject[ObjID].pVertexST[i].y = - pScene->pObject[ObjID].pVertexST[i].y;
//				printf ("mapping vertices %i   mx=%f, my=%f\n", i,	pScene->pObject[ObjID].pVertexST[i].x, pScene->pObject[ObjID].pVertexST[i].y);
	}
}



void mesh3ds::ReadFaceData(chunk *p_chunk)
{
			unsigned int i;
			unsigned short faces [6];
			unsigned short numb_f, numb_f2, temp_diff, number;
			chunk *tmp_chunk;
			tmp_chunk = new chunk;
			p_chunk->bytes+=fread(&numb_f, 1, sizeof(numb_f), P_File);
//				printf ("Found (%d) number of faces\n", numb_f);
				pScene->pObject[ObjID].num_face = numb_f;
				pScene->pObject[ObjID].pIndFaceArray = new int[numb_f*3];
				pScene->pObject[ObjID].pSmoothFaceArray = new int[numb_f];

				for(i=0;i<numb_f; i++)
				{
					int j=i*3;
					p_chunk->bytes+=fread (&(faces [0]),1, sizeof (short),P_File);
					p_chunk->bytes+=fread (&(faces [1]),1,sizeof (short),P_File);
					p_chunk->bytes+=fread (&(faces [2]),1,sizeof (short),P_File);
					p_chunk->bytes+=fread (&(temp_diff),1,sizeof (temp_diff),P_File);
					temp_diff= temp_diff & 0x000F;
					faces [3]=(temp_diff & 0x0004);
					faces [4]=(temp_diff & 0x0002);
					faces [5]=(temp_diff & 0x0001);
					pScene->pObject[ObjID].pIndFaceArray[j+0] = faces[0];
					pScene->pObject[ObjID].pIndFaceArray[j+1] = faces[1];
					pScene->pObject[ObjID].pIndFaceArray[j+2] = faces[2];

//					printf ("Face %i has   v1=%i, v2=%i,  v3=%i\n", i, faces [0], faces [1], faces [2]);
				}
					while(p_chunk->bytes<p_chunk->length)
					{
						ReadChunk(tmp_chunk);
						p_chunk->bytes+=tmp_chunk->length;
						switch(tmp_chunk->label)
							{
								case TRIANGLE_MATERIAL:
									{
//										printf("TRIANGLE_MATERIAL       %0x          %i\n", tmp_chunk->label, tmp_chunk->length); 
										ReadTextureName();
//										SetChunkPointer(tmp_chunk->length-6);
										p_chunk->bytes+=fread (&numb_f2,1,sizeof (short),P_File);
										printf ("Number of faces %d\n", numb_f2);
										for (i=0; i<numb_f2; i++)
										{
											fread (&number,sizeof (short),1,P_File);
										}
									}
								break;

/*
					case TRI_SMOOTH:
						{
						printf("TRI_SMOOTH   %0x          %i\n", tmp_chunk->label, tmp_chunk->length); 
//						ReadMappingData();
				for(i=0;i<numb_f2; i++)
				{
					fread (&(pScene->pObject[ObjID].pSmoothFaceArray[i]),1, sizeof (short),P_File);
					printf ("Face %i has  smoothing\n", pScene->pObject[ObjID].pSmoothFaceArray[i]);
				}
//						SetChunkPointer(tmp_chunk->length-6);
						}
					break;
*/
								default:
									{
										SetChunkPointer(tmp_chunk->length-6);	
									}
								break;
							}
					}
					delete tmp_chunk;
//					printf("Bytes read in NamedObjectChunk  %i\n", p_chunk->bytes); 
//					return j;
			}





void mesh3ds::ReadTriangleMeshChunk(chunk *p_chunk)
			{
			chunk *tmp_chunk;
			tmp_chunk = new chunk;

			while(p_chunk->bytes<p_chunk->length)
				{
				ReadChunk(tmp_chunk);
				p_chunk->bytes+=tmp_chunk->length;
				switch(tmp_chunk->label)
					{
					case TRIANGLE_VERTEXLIST:
						{
//						printf("TRIANGLE_VERTEXLIST     %0x          %i\n", tmp_chunk->label, tmp_chunk->length); 
						ReadVertexData();
//						SetChunkPointer(tmp_chunk->length-6);
						}
					break;

					case TRIANGLE_FACELIST:
						{
//						printf("TRIANGLE_FACELIST       %0x          %i\n", tmp_chunk->label, tmp_chunk->length);
						ReadFaceData(tmp_chunk);
//						SetChunkPointer(tmp_chunk->length-6);
						}
					break;

					case TRIANGLE_MAPPINGCOORS:
						{
//						printf("TRIANGLE_MAPPINGCOORS   %0x          %i\n", tmp_chunk->label, tmp_chunk->length); 
						ReadMappingData();
//						SetChunkPointer(tmp_chunk->length-6);
						}
					break;

					default:
						{
						SetChunkPointer(tmp_chunk->length-6);	
						}
					break;
					}
				}
				delete tmp_chunk;
//				printf("Bytes read in TriangleMeshChunk  %i\n", p_chunk->bytes); 				
}



void mesh3ds::ReadNamedObjectChunk(chunk *p_chunk)
{
		chunk *tmp_chunk;
		tmp_chunk = new chunk;
		p_chunk->bytes+=ReadObjectName ();
		while(p_chunk->bytes<p_chunk->length)
		{
				ReadChunk(tmp_chunk);
				p_chunk->bytes+=tmp_chunk->length;
				switch(tmp_chunk->label)
				{
						case TRIANGLE_MESH:
						{
//								printf("TRIANGLE_MESH       %0x          %i\n", tmp_chunk->label, tmp_chunk->length); 
								ReadTriangleMeshChunk(tmp_chunk);
//								SetChunkPointer(tmp_chunk->length-6);
						}
						break;

						default:
						{
								SetChunkPointer(tmp_chunk->length-6);	
						}
						break;
				}
		}
		delete tmp_chunk;
//					printf("Bytes read in NamedObjectChunk  %i\n", p_chunk->bytes); 
}



void mesh3ds::ReadEdit3DSChunk(chunk *p_chunk)
{
		chunk *tmp_chunk;
		tmp_chunk = new chunk;
		while(p_chunk->bytes<p_chunk->length)
		{
				ReadChunk(tmp_chunk);
				p_chunk->bytes+=tmp_chunk->length;
				switch(tmp_chunk->label)
				{
						case NAMED_OBJECT:
						{
//								printf("\nNAMED_OBJECT        %0x          %i\n", tmp_chunk->label, tmp_chunk->length); 
								ReadNamedObjectChunk(tmp_chunk);
//								SetChunkPointer(tmp_chunk->length-6);
								ObjID++;
						}
						break;

						case EDIT_MATERIAL:
						{
//								printf("\nEDIT_MATERIAL       %0x          %i\n", tmp_chunk->label, tmp_chunk->length); 
								ReadEditMaterialChunk(tmp_chunk);
//								SetChunkPointer(tmp_chunk->length-6);	
								pScene->pMaterial[MatID].MaterialId = MatID;
								MatID++;

						}
						break;

						default:
						{
								SetChunkPointer(tmp_chunk->length-6);	
						}
						break;
				}
		}
		delete tmp_chunk;
//		printf("Bytes read in Edit3ds       %i\n", p_chunk->bytes); 
}


void mesh3ds::Get3DSFileInfo(chunk *p_chunk)
{
		unsigned long ptr = GetChunkPosition();
		chunk *tmp_chunk;
		tmp_chunk = new chunk;
		while(p_chunk->bytes<p_chunk->length)
		{
				ReadChunk(tmp_chunk);
				p_chunk->bytes+=tmp_chunk->length;
				switch(tmp_chunk->label)
				{
						case NAMED_OBJECT:
						{
								num_obj++;
								SetChunkPointer(tmp_chunk->length-6);
						}
						break;

						case EDIT_MATERIAL:
						{
								num_mtr++;
								SetChunkPointer(tmp_chunk->length-6);
						}
						break;

						default:
						{
								SetChunkPointer(tmp_chunk->length-6);	
						}
						break;
				}
		}
		delete tmp_chunk;
		SetChunkPosition(ptr);
		pScene->num_objects = num_obj;
		pScene->num_materials = num_mtr;

//		printf("Found %i objects\n", num_obj);
//		printf("Found %i materials\n", num_mtr);
}


void mesh3ds::MakeFaceNormals(void)
{
		for (int i=0;i<pScene->num_objects;i++)
		{
				Face * pFace = new Face[pScene->pObject[i].num_face];
				pScene->pObject[i].pVertexArray = new Vector3D [pScene->pObject[i].num_face * 3];
				pScene->pObject[i].pVertexSTArray = new Vector2D [pScene->pObject[i].num_face * 3];
				pScene->pObject[i].pNormalArray = new Vector3D [pScene->pObject[i].num_face * 3];
				pScene->pObject[i].pBinormalArray = new Vector3D [pScene->pObject[i].num_face * 3];
				pScene->pObject[i].pTangentArray = new Vector3D [pScene->pObject[i].num_face * 3];
				pScene->pObject[i].pFace = new tFace [pScene->pObject[i].num_face];

				Vector3D * tmp_normal = new Vector3D [pScene->pObject[i].num_vertex];
				memset(tmp_normal,0,(sizeof(Vector3D)*pScene->pObject[i].num_vertex));

				Vector3D * tmp_binormal = new Vector3D [pScene->pObject[i].num_vertex];
				memset(tmp_binormal,0,(sizeof(Vector3D)*pScene->pObject[i].num_vertex));

				Vector3D * tmp_tangent = new Vector3D [pScene->pObject[i].num_vertex];
				memset(tmp_tangent,0,(sizeof(Vector3D)*pScene->pObject[i].num_vertex));


				for (int j=0;j<pScene->pObject[i].num_face;j++)
				{
						int k = j*3;

						int v0 = pScene->pObject[i].pIndFaceArray[k];
						int v1 = pScene->pObject[i].pIndFaceArray[k+1];
						int v2 = pScene->pObject[i].pIndFaceArray[k+2];

						pFace[j].v0 = pScene->pObject[i].pVertex[v0];
						pFace[j].v1 = pScene->pObject[i].pVertex[v1];
						pFace[j].v2 = pScene->pObject[i].pVertex[v2];

						pFace[j].st0 = pScene->pObject[i].pVertexST[v0];
						pFace[j].st1 = pScene->pObject[i].pVertexST[v1];
						pFace[j].st2 = pScene->pObject[i].pVertexST[v2];

						pFace[j].Norm = ((pFace[j].v1 - pFace[j].v0)^(pFace[j].v2 - pFace[j].v0)).GetNormalized();
				
						Vector3D e0,e1,cp, n;
						e0 = Vector3D(  pFace[j].v1.x - pFace[j].v0.x,
										pFace[j].st1.x - pFace[j].st0.x,
										pFace[j].st1.y - pFace[j].st0.y);

						e1 = Vector3D(  pFace[j].v2.x - pFace[j].v0.x,
										pFace[j].st2.x - pFace[j].st0.x,
										pFace[j].st2.y - pFace[j].st0.y);

						cp = e0^e1;

						pFace[j].Tangent.x = -cp.y / cp.x;
						pFace[j].Binorm.x = -cp.z / cp.x;

						e0 = Vector3D(  pFace[j].v1.y - pFace[j].v0.y,
										pFace[j].st1.x - pFace[j].st0.x,
										pFace[j].st1.y - pFace[j].st0.y);

						e1 = Vector3D(  pFace[j].v2.y - pFace[j].v0.y,
										pFace[j].st2.x - pFace[j].st0.x,
										pFace[j].st2.y - pFace[j].st0.y);

						cp = e0^e1;

						pFace[j].Tangent.y = -cp.y / cp.x;
						pFace[j].Binorm.y = -cp.z / cp.x;

						e0 = Vector3D(  pFace[j].v1.z - pFace[j].v0.z,
										pFace[j].st1.x - pFace[j].st0.x,
										pFace[j].st1.y - pFace[j].st0.y);

						e1 = Vector3D(  pFace[j].v2.z - pFace[j].v0.z,
										pFace[j].st2.x - pFace[j].st0.x,
										pFace[j].st2.y - pFace[j].st0.y);

						cp = e0^e1;

						pFace[j].Tangent.z = -cp.y / cp.x;
						pFace[j].Binorm.z = -cp.z / cp.x;

						pFace[j].Binorm.Normalize();
						pFace[j].Tangent.Normalize();

						n = (pFace[j].Tangent^pFace[j].Binorm).GetNormalized();

						pFace[j].Binorm = (n^pFace[j].Tangent).GetNormalized();

						tmp_normal[v0] += pFace[j].Norm;
						tmp_normal[v1] += pFace[j].Norm;
						tmp_normal[v2] += pFace[j].Norm;

						tmp_binormal[v0] += pFace[j].Binorm;
						tmp_binormal[v1] += pFace[j].Binorm;
						tmp_binormal[v2] += pFace[j].Binorm;

						tmp_tangent[v0] += pFace[j].Tangent;
						tmp_tangent[v1] += pFace[j].Tangent;
						tmp_tangent[v2] += pFace[j].Tangent;


				}


				pScene->pObject[i].min = Vector3D(9999999,9999999,9999999);
				pScene->pObject[i].max = Vector3D(-9999999,-9999999,-9999999);

				for (j=0;j<pScene->pObject[i].num_face;j++)
				{
						int k = j*3;
						int v0 = pScene->pObject[i].pIndFaceArray[k];
						int v1 = pScene->pObject[i].pIndFaceArray[k+1];
						int v2 = pScene->pObject[i].pIndFaceArray[k+2];

						pScene->pObject[i].pVertexArray[k] = pScene->pObject[i].pVertex[v0];
						pScene->pObject[i].pVertexArray[k+1] = pScene->pObject[i].pVertex[v1];
						pScene->pObject[i].pVertexArray[k+2] = pScene->pObject[i].pVertex[v2];

						pScene->pObject[i].pVertexSTArray[k] = pScene->pObject[i].pVertexST[v0];
						pScene->pObject[i].pVertexSTArray[k+1] = pScene->pObject[i].pVertexST[v1];
						pScene->pObject[i].pVertexSTArray[k+2] = pScene->pObject[i].pVertexST[v2];

						pScene->pObject[i].pNormalArray[k] = tmp_normal[v0].Normalize();
						pScene->pObject[i].pNormalArray[k+1] = tmp_normal[v1].Normalize();
						pScene->pObject[i].pNormalArray[k+2] = tmp_normal[v2].Normalize();

						pScene->pObject[i].pBinormalArray[k] = tmp_binormal[v0].Normalize();
						pScene->pObject[i].pBinormalArray[k+1] = tmp_binormal[v1].Normalize();
						pScene->pObject[i].pBinormalArray[k+2] = tmp_binormal[v2].Normalize();

						pScene->pObject[i].pTangentArray[k] = tmp_tangent[v0].Normalize();
						pScene->pObject[i].pTangentArray[k+1] = tmp_tangent[v1].Normalize();
						pScene->pObject[i].pTangentArray[k+2] = tmp_tangent[v2].Normalize();

						pScene->pObject[i].pFace[j].v0 = pScene->pObject[i].pVertexArray[k];
						pScene->pObject[i].pFace[j].v1 = pScene->pObject[i].pVertexArray[k+1];
						pScene->pObject[i].pFace[j].v2 = pScene->pObject[i].pVertexArray[k+2];

						pScene->pObject[i].pFace[j].st0 = pScene->pObject[i].pVertexSTArray[k];
						pScene->pObject[i].pFace[j].st1 = pScene->pObject[i].pVertexSTArray[k+1];
						pScene->pObject[i].pFace[j].st2 = pScene->pObject[i].pVertexSTArray[k+2];

						pScene->pObject[i].pFace[j].n0 = pScene->pObject[i].pNormalArray[k];
						pScene->pObject[i].pFace[j].n1 = pScene->pObject[i].pNormalArray[k+1];
						pScene->pObject[i].pFace[j].n2 = pScene->pObject[i].pNormalArray[k+2];

/*
						fprintf(P_LogFile, "\n\n\nface=%i\n",j);
						fprintf(P_LogFile, "v0.x=%2.2f   v0.y=%2.2f    v0.z=%2.2f\n", pScene->pObject[i].pVertexArray[k].x,
																		  pScene->pObject[i].pVertexArray[k].y,
																		  pScene->pObject[i].pVertexArray[k].z);

						fprintf(P_LogFile, "n0.x=%2.2f   n0.y=%2.2f    n0.z=%2.2f\n", pScene->pObject[i].pNormalArray[k].x,
																		  pScene->pObject[i].pNormalArray[k].y,
																		  pScene->pObject[i].pNormalArray[k].z);

						fprintf(P_LogFile, "t0.x=%2.2f   t0.y=%2.2f    t0.z=%2.2f\n", pScene->pObject[i].pTangentArray[k].x,
																		  pScene->pObject[i].pTangentArray[k].y,
																		  pScene->pObject[i].pTangentArray[k].z);

						fprintf(P_LogFile, "b0.x=%2.2f   b0.y=%2.2f    b0.z=%2.2f\n", pScene->pObject[i].pBinormalArray[k].x,
																		  pScene->pObject[i].pBinormalArray[k].y,
																		  pScene->pObject[i].pBinormalArray[k].z);

						fprintf(P_LogFile, "st0.x=%2.2f   st0.y=%2.2f \n",  pScene->pObject[i].pVertexSTArray[k].x,
																pScene->pObject[i].pVertexSTArray[k].y);



						fprintf(P_LogFile, "\nv1.x=%2.2f   v1.y=%2.2f    v1.z=%2.2f\n", pScene->pObject[i].pVertexArray[k+1].x,
																		  pScene->pObject[i].pVertexArray[k+1].y,
																		  pScene->pObject[i].pVertexArray[k+1].z);

						fprintf(P_LogFile, "n1.x=%2.2f   n1.y=%2.2f    n1.z=%2.2f\n", pScene->pObject[i].pNormalArray[k+1].x,
																		  pScene->pObject[i].pNormalArray[k+1].y,
																		  pScene->pObject[i].pNormalArray[k+1].z);

						fprintf(P_LogFile, "t1.x=%2.2f   t1.y=%2.2f    t1.z=%2.2f\n", pScene->pObject[i].pTangentArray[k+1].x,
																		  pScene->pObject[i].pTangentArray[k+1].y,
																		  pScene->pObject[i].pTangentArray[k+1].z);

						fprintf(P_LogFile, "b1.x=%2.2f   b1.y=%2.2f    b1.z=%2.2f\n", pScene->pObject[i].pBinormalArray[k+1].x,
																		  pScene->pObject[i].pBinormalArray[k+1].y,
																		  pScene->pObject[i].pBinormalArray[k+1].z);

						fprintf(P_LogFile, "st1.x=%2.2f   st1.y=%2.2f \n",  pScene->pObject[i].pVertexSTArray[k+1].x,
																pScene->pObject[i].pVertexSTArray[k+1].y);



						fprintf(P_LogFile, "\nv2.x=%2.2f   v2.y=%2.2f    v2.z=%2.2f\n", pScene->pObject[i].pVertexArray[k+2].x,
																		  pScene->pObject[i].pVertexArray[k+2].y,
																		  pScene->pObject[i].pVertexArray[k+2].z);

						fprintf(P_LogFile, "n2.x=%2.2f   n2.y=%2.2f    n2.z=%2.2f\n", pScene->pObject[i].pNormalArray[k+2].x,
																		  pScene->pObject[i].pNormalArray[k+2].y,
																		  pScene->pObject[i].pNormalArray[k+2].z);

						fprintf(P_LogFile, "t2.x=%2.2f   t2.y=%2.2f    t2.z=%2.2f\n", pScene->pObject[i].pTangentArray[k+2].x,
																		  pScene->pObject[i].pTangentArray[k+2].y,
																		  pScene->pObject[i].pTangentArray[k+2].z);

						fprintf(P_LogFile, "b2.x=%2.2f   b2.y=%2.2f    b2.z=%2.2f\n", pScene->pObject[i].pBinormalArray[k+2].x,
																		  pScene->pObject[i].pBinormalArray[k+2].y,
																		  pScene->pObject[i].pBinormalArray[k+2].z);

						fprintf(P_LogFile, "st2.x=%2.2f   st2.y=%2.2f \n",  pScene->pObject[i].pVertexSTArray[k+2].x,
																pScene->pObject[i].pVertexSTArray[k+2].y);

*/
						if (pScene->pObject[i].min.x >= pScene->pObject[i].pVertex[v0].x)
						{
								pScene->pObject[i].min.x  = pScene->pObject[i].pVertex[v0].x;
						}
						if (pScene->pObject[i].min.y >= pScene->pObject[i].pVertex[v0].y)
						{
								pScene->pObject[i].min.y  = pScene->pObject[i].pVertex[v0].y;
						}
						if (pScene->pObject[i].min.z >= pScene->pObject[i].pVertex[v0].z)
						{
								pScene->pObject[i].min.z  = pScene->pObject[i].pVertex[v0].z;
						}


						if (pScene->pObject[i].min.x >= pScene->pObject[i].pVertex[v1].x)
						{
								pScene->pObject[i].min.x  = pScene->pObject[i].pVertex[v1].x;
						}
						if (pScene->pObject[i].min.y >= pScene->pObject[i].pVertex[v1].y)
						{
								pScene->pObject[i].min.y  = pScene->pObject[i].pVertex[v1].y;
						}
						if (pScene->pObject[i].min.z >= pScene->pObject[i].pVertex[v1].z)
						{
								pScene->pObject[i].min.z  = pScene->pObject[i].pVertex[v1].z;
						}


						if (pScene->pObject[i].min.x >= pScene->pObject[i].pVertex[v2].x)
						{
								pScene->pObject[i].min.x  = pScene->pObject[i].pVertex[v2].x;
						}
						if (pScene->pObject[i].min.y >= pScene->pObject[i].pVertex[v2].y)
						{
								pScene->pObject[i].min.y  = pScene->pObject[i].pVertex[v2].y;
						}
						if (pScene->pObject[i].min.z >= pScene->pObject[i].pVertex[v2].z)
						{
								pScene->pObject[i].min.z  = pScene->pObject[i].pVertex[v2].z;
						}




						if (pScene->pObject[i].max.x < pScene->pObject[i].pVertex[v0].x)
						{
								pScene->pObject[i].max.x  = pScene->pObject[i].pVertex[v0].x;
						}
						if (pScene->pObject[i].max.y < pScene->pObject[i].pVertex[v0].y)
						{
								pScene->pObject[i].max.y  = pScene->pObject[i].pVertex[v0].y;
						}
						if (pScene->pObject[i].max.z < pScene->pObject[i].pVertex[v0].z)
						{
								pScene->pObject[i].max.z  = pScene->pObject[i].pVertex[v0].z;
						}


						if (pScene->pObject[i].max.x < pScene->pObject[i].pVertex[v1].x)
						{
								pScene->pObject[i].max.x  = pScene->pObject[i].pVertex[v1].x;
						}
						if (pScene->pObject[i].max.y < pScene->pObject[i].pVertex[v1].y)
						{
								pScene->pObject[i].max.y  = pScene->pObject[i].pVertex[v1].y;
						}
						if (pScene->pObject[i].max.z < pScene->pObject[i].pVertex[v1].z)
						{
								pScene->pObject[i].max.z  = pScene->pObject[i].pVertex[v1].z;
						}


						if (pScene->pObject[i].max.x < pScene->pObject[i].pVertex[v2].x)
						{
								pScene->pObject[i].max.x  = pScene->pObject[i].pVertex[v2].x;
						}
						if (pScene->pObject[i].max.y < pScene->pObject[i].pVertex[v2].y)
						{
								pScene->pObject[i].max.y  = pScene->pObject[i].pVertex[v2].y;
						}
						if (pScene->pObject[i].max.z < pScene->pObject[i].pVertex[v2].z)
						{
								pScene->pObject[i].max.z  = pScene->pObject[i].pVertex[v2].z;
						}



				}
				delete []pFace;
				delete tmp_normal;
				delete tmp_binormal;
				delete tmp_tangent;
		}
}



void mesh3ds::CompareMaterials(void)
{
//	fprintf(P_LogFile,"\nThis model has objects  %i\n",pModel->NumObjects);
//	fprintf(P_LogFile,"This model has materials  %i\n",pModel->NumMaterials);

		for (int i=0; i<pScene->num_objects; i++)
		{
				for (int j=0; j<pScene->num_materials; j++)
				{
						if (strcmp(pScene->pObject[i].strTextureName, pScene->pMaterial[j].strMaterialName)==0)
						{
//								fprintf(P_LogFile,"OK=\n"); 
								pScene->pObject[i].TextureID = pScene->pMaterial[j].MaterialId;
						}
			
//				fprintf(P_LogFile,"Material ID       = %i\n", pModel->pMaterial[j].MaterialId);
//				fprintf(P_LogFile,"Material      name= %s\n", pModel->pMaterial[j].strMaterialName);
//				fprintf(P_LogFile,"Material file name= %s\n", pModel->pMaterial[j].strFileName);
//				pModel->pObject[i].TextureID = 5;
				}
//				fprintf(P_LogFile,"\nObject         ID=%i\n", pModel->pObject[i].ObjectID);
//				fprintf(P_LogFile,"\nObject texture   ID=%i\n", pModel->pObject[i].TextureID);
//				fprintf(P_LogFile,"Object texture name= %s\n\n", pModel->pObject[i].strTextureName);
//				fprintf(P_LogFile,"Object         name= %s\n\n", pModel->pObject[i].strObjectName);
		}	
}




T3DScene * mesh3ds::Load3ds(const char * name)
{
	chunk *tmp_chunk = new chunk;
	chunk *tmp2_chunk = new chunk;
	chunk *p_chunk = new chunk;

	pScene = new T3DScene;

	char *ext = strrchr(name,'.');
	if(!ext) {
//		printf("unknown file format");
		return NULL;
	}
	if(strcmp(ext,".3ds")) 
	{
//		fprintf(stderr,"file \"%s\" not supported\n",name);
		return NULL;
	}

	P_File = fopen(name,"rb");
	if(!P_File) {
//		fprintf(stderr,"error open \"%s\" file\n",name);
		return NULL;
	}




		ReadChunk(p_chunk);
		printf("MAIN3DS      %0x          %i\n", p_chunk->label, p_chunk->length);
		while(p_chunk->bytes<p_chunk->length)
		{
				ReadChunk(tmp_chunk);
				memcpy(tmp2_chunk, tmp_chunk, sizeof(chunk));
				p_chunk->bytes+=tmp_chunk->length;

				switch(tmp_chunk->label)
				{
						case VERSION:
						{
								unsigned int version;
								fread(&version, 1, sizeof(version), P_File);
//								printf("VERSION=%i       %0x          %i\n",version, tmp_chunk->label, tmp_chunk->length); 
						}
						break;

						case EDIT3DS:
						{
//								printf("\nEDIT3DS             %0x          %i\n", tmp_chunk->label, tmp_chunk->length);
								Get3DSFileInfo(tmp2_chunk);
								pScene->pObject = new T3DObjectMesh [num_obj];
								pScene->pMaterial = new T3DMaterialMesh [num_mtr];
								ReadEdit3DSChunk(tmp_chunk);
						}
						break;

						case KEYF3DS:
						{
								SetChunkPointer(tmp_chunk->length-6);
//								printf("\nKEYF3DS             %0x          %i\n", tmp_chunk->label, tmp_chunk->length);
						}
						break;

						default:
						{
									SetChunkPointer(tmp_chunk->length-6);
//									printf("\nUNKNOWN             %0x          %i\n", tmp_chunk->label, tmp_chunk->length);
						}
						break;
				}
		}


	MakeFaceNormals();
	CompareMaterials();

	if(P_File) fclose(P_File);

	delete tmp_chunk;
	delete tmp2_chunk;
	delete p_chunk;
	return pScene;
}
































void mesh3ds::MakeTangentSpace(void)
{
	for (int i=0;i<pScene->num_objects;i++)
	{
		pScene->pObject[i].pTangentArray = new Vector3D[pScene->pObject[i].num_vertex];
		pScene->pObject[i].pBinormalArray = new Vector3D[pScene->pObject[i].num_vertex];
		pScene->pObject[i].pNormalArray = new Vector3D[pScene->pObject[i].num_vertex];
		for (int i=0;i<pScene->pObject[i].num_vertex;i++)
		{

		}
	}
}

