#include "myshader.h"



MyShader::MyShader()
{
	
}

MyShader::~MyShader()
{
	Release();	
}


bool MyShader::IsGLSLSupported()
{
	//   ,   
	char *szGLExtensions = (char*)glGetString(GL_EXTENSIONS);

	//     GL_ARB_shader_objects
	//    ,    
	if(!strstr(szGLExtensions, "GL_ARB_shader_objects"))
	{
		MessageBox(0, " GL_ARB_shader_objects  !", "Error", MB_OK);
		return false;
	}

	//      GLSL  1.0
	if(!strstr(szGLExtensions, "GL_ARB_shading_language_100"))
	{
		MessageBox(0, "   GL_ARB_shading_language_100  !", "Error", MB_OK);
		return false;
    }

	//      -    
	// GLSL-
    if( !glCreateProgramObjectARB || !glDeleteObjectARB || !glUseProgramObjectARB 
			||!glCreateShaderObjectARB || !glCreateShaderObjectARB || !glCompileShaderARB 
			|| !glAttachObjectARB ||!glLinkProgramARB||!glGetUniformLocationARB 
			|| !glUniform2fARB || !glUniform3fARB||!glUniform4fARB 
			||!glUniform1iARB || !glUniform1fARB || !glDetachObjectARB)
	{
        MessageBox(NULL,"         ",
        "ERROR",MB_OK|MB_ICONEXCLAMATION);
		return false;
	}

	return true;
}


char * MyShader::LoadFromFile(char * shader_name)
{
	char * data;
	file = fopen(shader_name,"rb");
	if(!file)
	{
        MessageBox(NULL,"     ",
        "ERROR",MB_OK|MB_ICONEXCLAMATION);
		return NULL;
	}
	
	fseek(file,0,SEEK_END);
	int size = ftell(file);
	data = new char[size + 1];
	data[size] = '\0';
	fseek(file,0,SEEK_SET);
	fread(data,1,size,file);
	fclose(file);
	return data;
}

void MyShader::InitShaders(char * vsh_name, char * fsh_name)
{
	vsh_object = glCreateShaderObjectARB(GL_VERTEX_SHADER_ARB);
	fsh_object = glCreateShaderObjectARB(GL_FRAGMENT_SHADER_ARB);

	vsh_data = LoadFromFile(vsh_name);
	fsh_data = LoadFromFile(fsh_name);

	glShaderSourceARB(vsh_object, 1, &vsh_data, NULL);
	glShaderSourceARB(fsh_object, 1, &fsh_data, NULL);

	glCompileShaderARB(vsh_object);
	glCompileShaderARB(fsh_object);

	GLint status = GL_FALSE;
	glGetObjectParameterivARB(vsh_object, GL_OBJECT_COMPILE_STATUS_ARB, &status);
	if (status== GL_FALSE)
	{
		MessageBox(NULL,"Vertex Shader not compiled",
        "ERROR",MB_OK|MB_ICONEXCLAMATION);
	}

	status = GL_FALSE;
	glGetObjectParameterivARB(fsh_object, GL_OBJECT_COMPILE_STATUS_ARB, &status);
	if (status== GL_FALSE)
	{
		MessageBox(NULL,"Fragment Shader not compiled",
        "ERROR",MB_OK|MB_ICONEXCLAMATION);
	}
	

	sh_program_object = glCreateProgramObjectARB();
	glAttachObjectARB(sh_program_object, vsh_object);
	glDeleteObjectARB(vsh_object);
	glAttachObjectARB(sh_program_object, fsh_object);
	glDeleteObjectARB(fsh_object);
	glLinkProgramARB(sh_program_object);
	status = GL_FALSE;
	glGetObjectParameterivARB(sh_program_object, GL_OBJECT_LINK_STATUS_ARB, &status);

	if (status == GL_FALSE)
	{
		MessageBox(NULL,"Shader program not not linked",
        "ERROR",MB_OK|MB_ICONEXCLAMATION);
	}
	
	glUseProgramObjectARB(sh_program_object);



}



void MyShader::Bind()
{	
	glUseProgramObjectARB(sh_program_object);
}

void MyShader::UnBind()
{	
	glUseProgramObjectARB(0);
}

void MyShader::Release()
{

	if(vsh_object)
	{
		glDetachObjectARB(sh_program_object, vsh_object);
		glDeleteObjectARB(vsh_object);
		vsh_object = NULL;
	}


	if(fsh_object)
	{
		glDetachObjectARB(sh_program_object, fsh_object);
		glDeleteObjectARB(fsh_object);
		fsh_object = NULL;
	}

	if(sh_program_object)
	{
		glDeleteObjectARB(sh_program_object);
		sh_program_object = NULL;
	}
}
