#ifndef _MYSHADER_H_
#define _MYSHADER_H_

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <gl\gl.h>										// Header File For The OpenGL32 Library
#include <gl\glu.h>										// Header File For The GLu32 Library
#include "InitGlExt.h"

#include <string>										// Used for our STL string objects
#include <fstream>


class MyShader
{
public:
		bool IsGLSLSupported();
		char * LoadFromFile(char * shader_name);
		void InitShaders(char * vertex_shader_name, char * fragment_shader_name);
		GLint GetVariable(char * UniformVariable);
		void Release();
		void Bind();
		void UnBind();
		MyShader();
		~MyShader();
public:
		FILE *file; 
		const char * vsh_data;
		const char * fsh_data;
		GLhandleARB vsh_object;
		GLhandleARB fsh_object;
		GLhandleARB sh_program_object;
};
#endif _MYSHADER_H_